;===================================================================;
;                                                                   ;
; Centipede                                                         ;
; Sprite routines                                                   ;
;                                                                   ;
;===================================================================;

;------------------------------------------------
; putSprite - Draw an 8x8 sprite to gbuf (using OR method), no clipping
; Usage:    #define PUT_SPRITE
;------------------------------------------------
putSprite:
        ld      h,0
        ld      b,h
        add     hl,hl                           ; x2
        add     hl,hl                           ; x4
#ifdef SPRITE_86
        add     hl,hl                           ; x8
        add     hl,hl                           ; x16
#else
        ld      c,l
        add     hl,hl                           ; x8
        add     hl,bc                           ; x12
#endif
        ld      c,a
        srl     c
        srl     c
        srl     c
        add     hl,bc
        ld      bc,gbuf
        add     hl,bc                           ; HL => Where to display sprite
        and     $07
        ld      c,a
        push    de
        pop     ix                              ; IX => Sprite
        ld      b,8
putSLoop:
        ld      d,(ix)
        ld      e,0
        ld      a,c
        or      a
        jr      z,putSSkip
putSLoop2:
        srl     d
        rr      e
        dec     a
        jr      nz,putSLoop2
putSSkip:
        ld      a,(hl)
        or      d
        ld      (hl),a
        inc     hl
        ld      a,(hl)
        or      e
        ld      (hl),a
#ifdef SPRITE_86
        ld      de,15
#else
        ld      de,11
#endif
        add     hl,de
        inc     ix
        djnz    putSLoop
        ret

.end
